# Method: provideValidationFeedback

- [HTTP request](https://developers.google.com/maps/documentation/address-validation/reference/rest/v1/TopLevel/provideValidationFeedback#body.HTTP_TEMPLATE)
- [Request body](https://developers.google.com/maps/documentation/address-validation/reference/rest/v1/TopLevel/provideValidationFeedback#body.request_body)
  - [JSON representation](https://developers.google.com/maps/documentation/address-validation/reference/rest/v1/TopLevel/provideValidationFeedback#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://developers.google.com/maps/documentation/address-validation/reference/rest/v1/TopLevel/provideValidationFeedback#body.response_body)
- [ValidationConclusion](https://developers.google.com/maps/documentation/address-validation/reference/rest/v1/TopLevel/provideValidationFeedback#ValidationConclusion)

Feedback about the outcome of the sequence of validation attempts. This should be the last call made after a sequence of validation calls for the same address, and should be called once the transaction is concluded. This should only be sent once for the sequence of `v1.validateAddress` requests needed to validate an address fully.

### HTTP request

`POST https://addressvalidation.googleapis.com/v1:provideValidationFeedback`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "conclusion": enum (`https://developers.google.com/maps/documentation/address-validation/reference/rest/v1/TopLevel/provideValidationFeedback#ValidationConclusion`), "responseId": string } ``` |

| Fields ||
|---|---|
| `conclusion` | ``enum (`https://developers.google.com/maps/documentation/address-validation/reference/rest/v1/TopLevel/provideValidationFeedback#ValidationConclusion`)`` Required. The outcome of the sequence of validation attempts. If this field is set to `VALIDATION_CONCLUSION_UNSPECIFIED`, an `INVALID_ARGUMENT` error will be returned. |
| `responseId` | `string` Required. The ID of the response that this feedback is for. This should be the \[responseId\]\[google.maps.addressvalidation.v1.ValidateAddressRequest.response_id\] from the first response in a series of address validation attempts. |

### Response body

If successful, the response body is empty.

## ValidationConclusion

The possible final outcomes of the sequence of address validation requests needed to validate an address.

| Enums ||
|---|---|
| `VALIDATION_CONCLUSION_UNSPECIFIED` | This value is unused. If the `ProvideValidationFeedbackRequest.conclusion` field is set to `VALIDATION_CONCLUSION_UNSPECIFIED`, an `INVALID_ARGUMENT` error will be returned. |
| `VALIDATED_VERSION_USED` | The version of the address returned by the Address Validation API was used for the transaction. |
| `USER_VERSION_USED` | The version of the address provided by the user was used for the transaction |
| `UNVALIDATED_VERSION_USED` | A version of the address that was entered after the last validation attempt but that was not re-validated was used for the transaction. |
| `UNUSED` | The transaction was abandoned and the address was not used. |